<template>
    <div class="component">
        <h3>Information User Details</h3>
        <p>List Details</p>
        <p>My Name: {{ reverseName() }}</p>
        <p>My Age: {{ userAge }}</p>
        <button @click="resetName">Rest Name</button>
        <button @click="resetNameFn()">Reset case: Call back</button>
    </div>
</template>

<script>
    import { eventBus } from '../main.js';
    export default {
        props: {
            customName: {
                type: Object,
                default: 'Sky Albert',
            }, 
            resetNameFn: Function,
            userAge: Number
        },
        methods: {
            reverseName() {
                return this.customName.split("").reverse().join("");
            },
            resetName() {
                this.customName = 'Sky Albert';
                this.$emit('nameWasReset', this.customName);
            }
        },
        created() {
            eventBus.$on('ageWasEdit', (age) => {
                this.userAge = age;
            })
        }
        
    }
</script>

<style scoped>
    div {
        background-color: lightcoral ;
    }
</style>

